package cl.utfsm.elo.khott.cliente.gui;

import java.awt.Color;
/**
 * Clase que guarda valores a representarse en una celda.
 * @author Janther
 */
public class Cell {
    /**
     * String a mostrarse en la Celda.
     */
    private String id;
    /**
     * Color del Fondo de la Celda.
     */
    private Color fondo;
    /**
     * Color del texto de la Celda.
     */
    private Color texto;
    /**
     * Texto a mostrarse cuando el mouse esta sobre la Celda.
     */
    private String toolTip;

    /**
     * Constructor de la clase.
     * @param nombre String a mostrarse en la Celda.
     * @param fond Color del Fondo de la Celda.
     * @param text Color del texto de la Celda.
     * @param tip Texto a mostrarse cuando el mouse esta sobre la Celda.
     */
    public Cell (String nombre, Color fond, Color text, String tip) {
        id = nombre;
        fondo = fond;
        texto = text;
        toolTip = tip;
    }

    /**
     * Para acceder al id de la Celda.
     * @return id de la Celda.
     */
    public String getId() {
        return id;
    }

    /**
     * Para acceder al Color de Fondo de la Celda.
     * @return Color de Fondo de la Celda.
     */
    public Color getColorFondo() {
        return fondo;
    }

    /**
     * Para acceder al Color de Texto de la Celda.
     * @return Color de Texto de la Celda.
     */
    public Color getColorText() {
        return texto;
    }

    /**
     * Para acceder al ToolTip de la Celda.
     * @return ToolTip de la Celda.
     */
    public String getToolTip() {
    	return toolTip;
    }
}
