package cl.utfsm.elo.khott.cliente.gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.border.TitledBorder;
import javax.swing.table.TableColumn;
import cl.utfsm.elo.khott.servidor.SalaInterfaz;

public class PanelHorario extends JPanel {
	/**
     * Numero Serial de la clase.
     */
    private static final long serialVersionUID = 1004;
    private String sala;
    private int weeck;
    private JTable tabla;

    public PanelHorario(String conexion, String sal, int semana) {
        super(new GridLayout(1,0));
        setBorder(new TitledBorder(this.getBorder(), "Semana " + semana));
        weeck = semana;

        sala = sal;
        tabla = crearTabla(conexion);
        

        tabla.setRowSelectionAllowed(false);
        tabla.setColumnSelectionAllowed(false);
        tabla.setCellSelectionEnabled(true);
        tabla.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tabla.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
        tabla.setDragEnabled(false);
        tabla.setPreferredScrollableViewportSize(new Dimension(600, 120));
        for (int i = 0; i < tabla.getColumnCount(); i++){
        	TableColumn tc = tabla.getColumnModel().getColumn(i);
        	tc.setCellRenderer(new SalaRenderer());
        }
    	
        JScrollPane scrollPane = new JScrollPane(tabla);
        add(scrollPane);
        setOpaque(true);
        setSize(600,145);
    }

	private JTable crearTabla(String conexion){
		tabla = new JTable();
        try {
        	SalaInterfaz aula = (SalaInterfaz)
                    Naming.lookup("rmi://" + conexion + "/" + sala);
            Vector < String > dias = new Vector < String > ();
            dias.add("Lunes");
            dias.add("Martes");
            dias.add("Miercoles");
            dias.add("Jueves");
            dias.add("Viernes");
            dias.add("Sabado");
	        Vector < Vector > rowData = new Vector <Vector> ();
	        Vector < Cell > data = new Vector < Cell > ();
	        for (int k = 0; k < 14; k++){
	            data.clear();
	        	for (int i = 0; i < dias.size(); i++) {
	        	    data.add(new Cell(
	        	            String.valueOf(k + 1),
	        	            aula.getColorHorario(weeck, i, k),
	        	            Color.WHITE,
	        	            ""));
	        	}
	        	rowData.add((Vector)data.clone());
	        }
	        tabla = new JTable(rowData, dias);
	    }
        catch (MalformedURLException murle) { 
            System.out.println(); 
            System.out.println("MalformedURLException"); 
            System.out.println(murle); 
        } 
        catch (RemoteException re) { 
            System.out.println(); 
            System.out.println("RemoteException"); 
            System.out.println(re); 
        } 
        catch (NotBoundException nbe) { 
            System.out.println(); 
            System.out.println("NotBoundException"); 
            System.out.println(nbe); 
        }
        return tabla;
	}
    public int getDia() {
        return tabla.getSelectedColumn();
    }
    public int getBloque() {
        return tabla.getSelectedRow();
    }
}
