package cl.utfsm.elo.khott.cliente.gui;

import javax.swing.table.DefaultTableCellRenderer;

/**
 * Clase que decide como mostrar una Celda por pantalla.
 * @author Janther
 */
public class SalaRenderer extends DefaultTableCellRenderer {
    /**
     * Numero Serial de la clase.
     */
    static final long serialVersionUID = 1;

    /**
     * Decide como mostrar por pantalla la Celda, basado el los valores de
     * esta.
     * @param value Objeto a renderear, posiblemente Celda.
     */
    public final void setValue(final Object value) {
        if (value instanceof Cell) {
            Cell c = (Cell) value;
            setBackground(c.getColorFondo());
            setForeground(c.getColorText());
            setText(c.getId());
            setToolTipText(c.getToolTip());
            setHorizontalAlignment(DefaultTableCellRenderer.CENTER);
        } else {
            super.setValue(value);
        }
    }
}
