package cl.utfsm.elo.khott.servidor;

import java.io.*;
import javax.swing.*;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;
import java.rmi.*;

public class Datos extends UnicastRemoteObject implements DatosInterfaz {
	/**
     * Numero Serial de la clase.
     */
    private static final long serialVersionUID = 1008;
    public Datos() throws RemoteException {}
    static private Sala crearSala(String id) {
        try {
        	FileReader inputFile =
        	    new FileReader("data/" + id.charAt(0) + ".edi");
            BufferedReader in = new BufferedReader(inputFile);
            while (!in.readLine().matches("#EOF#")) {
            	String line = in.readLine();
                if (line.matches(id)) {
                	int cupo = Integer.parseInt(in.readLine());
                    return new Sala(id, cupo);
                }
            }
            in.close();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public Sala cargarSala(String id) throws RemoteException {
        Sala sala;
        try {
            FileInputStream input =
                new FileInputStream("data/"+ id +".sala");
            ObjectInputStream in = new ObjectInputStream(input);
            sala = (Sala)in.readObject();
            in.close();
        }
        catch (IOException e) {
            sala = crearSala(id);
        }
        catch (ClassNotFoundException e) {
        	sala = crearSala(id);
        }
        return sala;
    }

    public void guardarSala(Sala sala) throws RemoteException {
        try {  
            FileOutputStream output = 
                new FileOutputStream("data/" + sala.getId() +".sala");
            ObjectOutputStream out = new ObjectOutputStream(output);
            out.writeObject(sala);
            out.close();
        }
        catch (Exception e) {  
            e.printStackTrace();
        }
    }

    public Vector < String > vectorSalas() throws RemoteException {
    	Vector < String > items = new Vector < String > ();
        
        try {
        	FileReader inputFile =
        	    new FileReader("data/Edificios");
            BufferedReader in = new BufferedReader(inputFile);

            while(in.readLine().startsWith("#"));
            while (!in.readLine().matches("#EOF#")) {
            	String edificio = in.readLine();
            	FileReader inputFile2 =
            	    new FileReader("data/" + edificio + ".edi");
                BufferedReader in2 = new BufferedReader(inputFile2);

                while (!in2.readLine().matches("#EOF#")) {
                	String line = in2.readLine();
                    if (line.startsWith(edificio)) {
                        items.add(line);
                    }
                }
                in2.close();
            }
            in.close();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        return items;
    }

    public Vector < String > vectorEdificios() throws RemoteException {
    	Vector < String > items = new Vector < String > ();
        try {
        	FileReader inputFile =
        	    new FileReader("data/Edificios");
            BufferedReader in = new BufferedReader(inputFile);

            while(in.readLine().startsWith("#"));
            while (!in.readLine().matches("#EOF#")) {
            	String edificio = in.readLine();
            	items.add(edificio);
            }
            in.close();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        return items;
    }

    public JComboBox comboSalas() throws RemoteException {
        JComboBox combo = new JComboBox(vectorSalas());
        return combo;
    }
}
