package cl.utfsm.elo.khott.servidor;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;
import java.awt.Color;

public class Sala extends UnicastRemoteObject implements SalaInterfaz {
	/**
     * Numero Serial de la clase.
     */
    private static final long serialVersionUID = 1007;
    private String id;
    private int capacidad;
    private ArrayList < Reserva > reservas;
    private Color fondo = Color.WHITE;
    private Color texto = Color.BLACK;
    private String toolTip;
    

    public Sala(String idSala, int cap) throws RemoteException {
        id = idSala;
        capacidad = cap;
        reservas = new ArrayList < Reserva > ();
    }

    public String getId() throws RemoteException {
        return id;
    }

    public int getCap() throws RemoteException {
        return capacidad;
    }

    public void addReserva(Reserva r) throws RemoteException {
        for (int i = 0; i < reservas.size(); i++) {
            Reserva re = reservas.get(i);
            if ((re.getMin() < r.getMax() || re.getMin() < r.getMax()) &&
                    re.getDia() == r.getDia() &&
                    re.getBloque() == r.getBloque()) {
                return;
            }
        }
        reservas.add(r);
        Datos data = new Datos();
        data.guardarSala(this);
        return;
    }

    public Color getColorFondo() throws RemoteException {
        return fondo;
    }
    public Color getColorText() throws RemoteException {
        return texto;
    }

    public String getToolTip() throws RemoteException {
    	return toolTip;
    }

    public void setColores(int min, int max, int alumnos)
            throws RemoteException {
    	int usado = 0;
    	int gente = 0;
        for (int i = 0; i < reservas.size(); i++) {
            Reserva r = reservas.get(i);
            if (max > r.getMin() || min < r.getMax()) {
            	usado = usado + Math.min(max - r.getMin(), r.getMax() - min);
            }
        }
        gente = 255 - Math.abs(capacidad - alumnos) * 255 / (capacidad + alumnos);
        usado = 255 - usado * 255 / ((max - min) * 84);
        fondo = new Color(usado, gente, 255);
        final int limiteColor = 240;
        int r = fondo.getRed();
        int g = fondo.getGreen();
        if (r > limiteColor || g > limiteColor) {
            texto = Color.black;
        } else {
        	texto = Color.white;
        }
    }

    public Color getColorHorario(int weeck, int dia, int bloque)
            throws RemoteException {
    	for (int i = 0; i < reservas.size(); i++) {
    		Reserva r = reservas.get(i);
    	    if (weeck >= r.getMin() &&
    	            weeck <= r.getMax() &&
    	            ((Integer) dia).equals(r.getDia()) &&
    	            ((Integer) bloque).equals(r.getBloque())) {
    	        return Color.GREEN;
    	    }
    	}
        return Color.BLUE;
    }
}
