package cl.utfsm.elo.khott.servidor;

import java.rmi.Naming;
import java.util.*;

/**
 * Clase que implementa el servidor e inscribe las clases en el registro rmi.
 * @author Janther
 */
public class Servidor {

    /**
     * Constructor de la clase.
     */
    public Servidor() {
        try {
            DatosInterfaz data = new Datos();
            Naming.rebind("rmi://localhost:1099/Datos", data);
            Vector < String > idSalas = data.vectorSalas();
            for (int i = 0; i < idSalas.size(); i++) {
                SalaInterfaz sala = data.cargarSala(idSalas.get(i));
                Naming.rebind("rmi://localhost:1099/" + sala.getId(), sala);
            }
        }
        catch (Exception e) {
           System.out.println("Problema: " + e);
        }
    }

    /**
     * Main del programa.
     * @param args argumentos de ejecucion.
     */
    public static void main(String args[]) {
        new Servidor();
    }
}
